Pivot Slicer

SpreadJS PivotTable supports slicers, which are a convenient graphical interface for the label filter.

The demo is being dynamically compiled to support real-time code editing... For quicker access to features, switch to the "JavaScript" tab for a smoother experience! :)
Description
app.js
index.html
styles.css
Copy to CodeMine

Introduction SpreadJS PivotTable supports two types of slicers:

  • Item slicer
  • Timeline slicer

Same with table slicer, pivot slicer is also managed through slicer collection.

SpreadJS defined SlicerType to distinguish which type of slicer will be added.

    // GC.Spread.Sheets.Slicers.SlicerType
    enum SlicerType {
        table, // table slicer
        pivotTable, // pivot table item slicer
        pivotTimeline // pivot table timeline slicer
    }

Pivot Slicers work with 3 plugins: shapes, slicers, pivot-addon.

Item Slicers can be added to any field (excluding the Calc field). The changes made on an Item Slicer are equal to using the manual filter, which means "textItems" in the label filter.

Only Timeline Slicer can be added to the Date type field. The changes made on Timeline Slicer are equal to using the label condition filter, which means "condition" in the label filter.

For example, if we want to add a Pivot Table Item Slicer. Assuming that we have created a PivotTable named "pt".

    var spread = GC.Spread.Sheets.findControl(document.getElementById('ss'));
    var sheet = spread.getActiveSheet();
    var pt = sheet.pivotTables.get("pt");

If want to add an item slicer to the "name" field.

    var slicer_name = sheet.slicers.add("slicer_name", pt.name(), "name", GC.Spread.Sheets.Slicers.SlicerStyles.light1(), GC.Spread.Sheets.Slicers.SlicerType.pivotTable);

Also, assuming that pivot table "pt" has a date field named "birthday", and we want to add a Pivot Table Timeline Slicer.

    var slicer_birthday = sheet.slicers.add("slicer_birthday", pt.name(), "name", GC.Spread.Sheets.Slicers.TimelineStyles.light1(), GC.Spread.Sheets.Slicers.SlicerType.pivotTimeline);

You may have a question: It is obvious that item slicer and timeline slicer can be added to a date field at the same time. Can they work at the same time?

By default, no. They all work through labelFilter. Setting textItems will cause the condition filter to be lost. You can solve this problem with an option in PivotTable: allowMultipleFiltersPerField.

    pt.options.allowMultipleFiltersPerField = true;

Try to Filter by clicking and dragging items in the Slicer. With Item Slicer, you can also try pressing the shift and ctrl keys (for Windows) / command key (for Mac) when clicking or dragging.

Shape Base Pivot Slicer is based on Shape, so you can use some Shape API to control Pivot Slicer For example

    // set the slicer's position
    slicer_name.startRow(1)
    slicer_name.startColumn(6)
    slicer_name.startRowOffset(0)
    slicer_name.startColumnOffset(0)

    // set the slicer's size
    slicer_name.width(260);
    slicer_name.height(350);

    // set the slicer's selected
    slicer_name.isSelected(true);

Connect With PivotTable Pivot Slicer supports connection management, including connecting or disconnecting the PivotTable. If disconnecting from a PivotTable, the slicer filter action will not affect the PivotTable. PivotTable filter actions will also not affect a Slicer.

// slicer API
connectPivotTable (ptName: string): void // Connect pivot table with the slicer
disconnectPivotTable (ptName: string): void // Disconnect pivot table with the slicer
isConnectedPivotTable (ptName: string): boolean // Check whether pivot table connect with the slicer
getConnectedPivotTableNameList (): string[] // get all connected PivotTables' names.
getAllConnectedPivotTables (): PivotTable[] //  get all connected PivotTables
getAllPivotTables (): PivotTable[] // get all PivotTables whether connected or not.

// pivot table API
getAllSlicers (): GC.Spread.Pivot.PivotTableItemSlicer[] // Get All Slicers connect with the PivotTable
connectSlicer (name: string): void // Connect slicer with the PivotTable
disconnectSlicer (name: string): void // Disconnect slicer with PivotTable
isConnectedSlicer (name: string): boolean // Whether the slicer is connected with the PivotTable

For example, through this capability, you can use a slicer to manage multiple PivotTables from the same source. Assuming that there are two PivotTables "pt1" and "pt2", both of them are created from a table called "table1", so they have same data source and fields.

    var slicer_name = sheet.slicers.add("slicer_name", "pt1", "name", GC.Spread.Sheets.Slicers.SlicerStyles.light1(), GC.Spread.Sheets.Slicers.SlicerType.pivotTable);

    slicer_name.connectPivotTable("pt2");

Now you can use slicer_name to control the filters of two PivotTables.

Introduction SpreadJS PivotTable supports two types of slicers: Item slicerTimeline slicer Same with table slicer, pivot slicer is also managed through slicer collection. SpreadJS defined SlicerType to distinguish which type of slicer will be added. Pivot Slicers work with 3 plugins: shapes, slicers, pivot-addon. Item Slicers can be added to any field (excluding the Calc field). The changes made on an Item Slicer are equal to using the manual filter, which means "textItems" in the label filter. Only Timeline Slicer can be added to the Date type field. The changes made on Timeline Slicer are equal to using the label condition filter, which means "condition" in the label filter. For example, if we want to add a Pivot Table Item Slicer. Assuming that we have created a PivotTable named "pt". If want to add an item slicer to the "name" field. Also, assuming that pivot table "pt" has a date field named "birthday", and we want to add a Pivot Table Timeline Slicer. You may have a question: It is obvious that item slicer and timeline slicer can be added to a date field at the same time. Can they work at the same time? By default, no. They all work through labelFilter. Setting textItems will cause the condition filter to be lost. You can solve this problem with an option in PivotTable: allowMultipleFiltersPerField. Try to Filter by clicking and dragging items in the Slicer. With Item Slicer, you can also try pressing the shift and ctrl keys (for Windows) / command key (for Mac) when clicking or dragging. Shape Base Pivot Slicer is based on Shape, so you can use some Shape API to control Pivot Slicer For example Connect With PivotTable Pivot Slicer supports connection management, including connecting or disconnecting the PivotTable. If disconnecting from a PivotTable, the slicer filter action will not affect the PivotTable. PivotTable filter actions will also not affect a Slicer. For example, through this capability, you can use a slicer to manage multiple PivotTables from the same source. Assuming that there are two PivotTables "pt1" and "pt2", both of them are created from a table called "table1", so they have same data source and fields. Now you can use slicer_name to control the filters of two PivotTables.
window.onload = function () { var spread = new GC.Spread.Sheets.Workbook(_getElementById('ss'), { sheetCount: 2 }); initSpread(spread); var pivotLayoutSheet = spread.getSheet(0); initPivotTable(pivotLayoutSheet); initSlicer(pivotLayoutSheet); bindEvent(spread.getSheet(0)); }; function initSpread(spread) { spread.suspendPaint(); let sheet = spread.getSheet(1); sheet.name("DataSource"); sheet.setRowCount(650); sheet.setColumnWidth(5, 120); sheet.getCell(-1, 5).formatter("YYYY-mm-DD"); sheet.getRange(-1,4,0,1).formatter("$ #,##0"); sheet.setArray(0, 0, pivotSales); let table = sheet.tables.add('tableSales', 0, 0, 637, 6); table.style(GC.Spread.Sheets.Tables.TableThemes["none"]); let sheet0 = spread.getSheet(0); sheet0.name("PivotLayout"); sheet0.setValue(0, 0, "Pivot Table 1"); sheet0.setValue(0, 10, "Pivot Table 2"); spread.resumePaint(); } function initPivotTable(sheet) { var groupInfo = { originFieldName: "date", dateGroups: [{ by: GC.Pivot.DateGroupType.quarters }, {by: GC.Pivot.DateGroupType.years}, {by: GC.Pivot.DateGroupType.months}] }; var pt1 = sheet.pivotTables.add("pt1", "tableSales", 1, 0, GC.Spread.Pivot.PivotTableLayoutType.outline, GC.Spread.Pivot.PivotTableThemes.light8); pt1.suspendLayout(); pt1.options.showRowHeader = true; pt1.options.showColumnHeader = true; pt1.options.subtotalsPosition = GC.Spread.Pivot.SubtotalsPosition.top; pt1.layoutType(GC.Spread.Pivot.PivotTableLayoutType.compact); pt1.add("region", "region", GC.Spread.Pivot.PivotTableFieldType.rowField); pt1.add("country", "country", GC.Spread.Pivot.PivotTableFieldType.rowField); pt1.add("city", "city", GC.Spread.Pivot.PivotTableFieldType.rowField); pt1.add("amount", "amounts", GC.Spread.Pivot.PivotTableFieldType.valueField, GC.Pivot.SubtotalType.sum); pt1.resumeLayout(); pt1.autoFitColumn(); var pt2 = sheet.pivotTables.add("pt2", "tableSales", 1, 10, GC.Spread.Pivot.PivotTableLayoutType.outline, GC.Spread.Pivot.PivotTableThemes.medium23); pt2.suspendLayout(); pt2.options.showRowHeader = true; pt2.options.showColumnHeader = true; pt2.options.subtotalsPosition = GC.Spread.Pivot.SubtotalsPosition.top; pt2.layoutType(GC.Spread.Pivot.PivotTableLayoutType.compact); pt2.group(groupInfo); pt2.add("Years (date)", "Years (date)", GC.Spread.Pivot.PivotTableFieldType.rowField); pt2.add("Quarters (date)", "Quarters (date)", GC.Spread.Pivot.PivotTableFieldType.rowField); pt2.add("Days (date)", "Days (date)", GC.Spread.Pivot.PivotTableFieldType.rowField); pt2.add("amount", "Amounts", GC.Spread.Pivot.PivotTableFieldType.valueField, GC.Pivot.SubtotalType.sum); pt2.resumeLayout(); pt2.autoFitColumn(); } function initSlicer (sheet) { sheet.suspendPaint(); var yearSlicer = sheet.slicers.add("Years", 'pt2', "date", GC.Spread.Sheets.Slicers.TimelineStyles.light5(), GC.Spread.Sheets.Slicers.SlicerType.pivotTimeline); var monthSlicer = sheet.slicers.add("Months", 'pt2', "date", GC.Spread.Sheets.Slicers.TimelineStyles.light1(), GC.Spread.Sheets.Slicers.SlicerType.pivotTimeline); this.setTimelineProp(yearSlicer, 967, 20, 310, 160, 1, "Years"); this.setTimelineProp(monthSlicer, 967, 160, 310, 160, 3, "Months"); var regionSlicer = sheet.slicers.add("region", 'pt1', "region", GC.Spread.Sheets.Slicers.SlicerStyles.dark1(), GC.Spread.Sheets.Slicers.SlicerType.pivotTable); var countrySlicer = sheet.slicers.add("country", 'pt1', "country", GC.Spread.Sheets.Slicers.SlicerStyles.dark2(), GC.Spread.Sheets.Slicers.SlicerType.pivotTable); var citySlicer = sheet.slicers.add("city", 'pt1', "city", GC.Spread.Sheets.Slicers.SlicerStyles.dark3(), GC.Spread.Sheets.Slicers.SlicerType.pivotTable); this.setSlicerProp(regionSlicer, 285, 20, 140, 200, 1, true, true); this.setSlicerProp(countrySlicer, 425, 20, 140, 200, 1, true, true); this.setSlicerProp(citySlicer, 565, 20, 140, 200, 1, true, true); sheet.resumePaint(); } function setSlicerProp(slicer, x, y, width, height, columnCount, showHeader, showNoDataItemsInLast) { slicer.position({x, y}); slicer.width(width); slicer.height(height); if (columnCount) { slicer.columnCount(columnCount); } slicer.showHeader(!!showHeader); slicer.showNoDataItemsInLast(!!showNoDataItemsInLast); slicer.allowMove(false); slicer.allowResize(false); } function setTimelineProp (timeline, x, y, width, height, level, caption) { timeline.position({x, y}); timeline.width(width); timeline.height(height); timeline.level(level); timeline.captionName(caption); timeline.allowMove(false); timeline.allowResize(false); } function bindEvent (sheet) { var slicer; sheet.bind(GC.Spread.Sheets.Events.SlicerChanged, function () { var slicers = sheet.slicers.all(); for (var i = 0; i < slicers.length; i++) { if (slicers[i].isSelected()) { slicer = slicers[i]; updateSlicerInfo(slicer); break; } } }); ['name', 'captionName'].forEach(prop => { _getElementById(prop).addEventListener("change", function (e) { var value = e.target.value; if (value && slicer) { slicer[prop](value); } }); }); ['x', 'y', 'width', 'height'].forEach(prop => { _getElementById(prop).addEventListener("change", function (e) { var value = +e.target.value; if (value && slicer) { slicer[prop](value); } }); }); ['pt1', 'pt2'].forEach(ptName => { _getElementById(ptName).addEventListener("change", function (e) { var checked = e.target.checked; if (!_isNullOrUndefined(checked) && slicer) { if (checked) { slicer.connectPivotTable(ptName); } else { slicer.disconnectPivotTable(ptName); } } }); }); } function updateSlicerInfo (slicer) { _getElementById("name").value = slicer.name(); _getElementById("captionName").value = slicer.captionName(); _getElementById("x").value = slicer.x(); _getElementById("y").value = slicer.y(); _getElementById("width").value = slicer.width(); _getElementById("height").value = slicer.height(); _getElementById("pt1").checked = slicer.isConnectedPivotTable('pt1'); _getElementById("pt2").checked = slicer.isConnectedPivotTable('pt2'); } function _getElementById(id) { return document.getElementById(id); } function _isNullOrUndefined(o) { return o === null || o === undefined; }
<!doctype html> <html style="height:100%;font-size:14px;"> <head> <meta charset="utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0" /> <link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css"> <script src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/dist/gc.spread.sheets.all.min.js" type="text/javascript"></script> <script src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets-shapes/dist/gc.spread.sheets.shapes.min.js" type="text/javascript"></script> <script src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets-slicers/dist/gc.spread.sheets.slicers.min.js" type="text/javascript"></script> <script src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets-pivot-addon/dist/gc.spread.pivot.pivottables.min.js" type="text/javascript"></script> <script src="$DEMOROOT$/spread/source/data/pivotSales.js" type="text/javascript"></script> <script src="$DEMOROOT$/spread/source/js/license.js" type="text/javascript"></script> <script src="app.js" type="text/javascript"></script> <link rel="stylesheet" type="text/css" href="styles.css"> </head> <body> <div class="sample-tutorial"> <div id="ss" class="sample-spreadsheets"></div> <div class="options-container"> <div class="block slicer-infos"> <div>Current Selected Slicer Info:</div><br> <div class="slicer-info"> <label class="info-label">Slicer Name:</label> <input class="info-input" id="name"></input> </div> <div class="slicer-info"> <label class="info-label">Caption Name:</label> <input class="info-input" id="captionName"></input> </div> <div class="slicer-info"> <label class="info-label">X:</label> <input type="number" class="info-input" name="x" id="x", min="0", max="1000", step="1"> </div> <div class="slicer-info"> <label class="info-label">Y:</label> <input type="number" class="info-input" name="y" id="y", min="0", max="1000", step="1"> </div> <div class="slicer-info"> <label class="info-label">Width:</label> <input type="number" class="info-input" name="width" id="width", min="0", max="1000", step="1"> </div> <div class="slicer-info"> <label class="info-label">Height:</label> <input type="number" class="info-input" name="height" id="height", min="0", max="1000", step="1"> </div> </div> <div class="block"> <div>Slicer Connection</div><br/> <div class="Connection"> <div class="slicer-info"> <input type="checkbox" id="pt1"> <label for="pt1">Connect Pivot Table 1</label> </div> <div class="slicer-info"> <input type="checkbox" id="pt2"> <label for="pt2">Connect Pivot Table 2</label> </div> </div> </div> </div> </div> </body> </html>
.sample-tutorial { position: relative; height: 100%; overflow: hidden; } .sample-spreadsheets { width: calc(100% - 330px); height: 100%; overflow: hidden; float: left; } .options-container { float: right; width: 330px; padding: 12px; height: 100%; box-sizing: border-box; background: #fbfbfb; overflow: auto; } body { position: absolute; top: 0; bottom: 0; left: 0; right: 0; } .slicer-info { margin-top: 5px; margin-bottom: 5px; } .block { border: 1px solid gray; padding-left: 5px; padding-top: 10px; padding-bottom: 10px; margin-bottom: 1px; } .info-label { width: 35%; display: inline-block; } .info-input { width: 58%; display: inline-block; }

Introduction
SpreadJS PivotTable supports two types of slicers:
Item slicerTimeline slicer
Same with table slicer, pivot slicer is also managed through slicer collection.
SpreadJS defined SlicerType to distinguish which type of slicer will be added.
Pivot Slicers work with 3 plugins: shapes, slicers, pivot-addon.
Item Slicers can be added to any field (excluding the Calc field).
The changes made on an Item Slicer are equal to using the manual filter, which means "textItems" in the label filter.
Only Timeline Slicer can be added to the Date type field.
The changes made on Timeline Slicer are equal to using the label condition filter, which means "condition" in the label filter.
For example, if we want to add a Pivot Table Item Slicer.
Assuming that we have created a PivotTable named "pt".
If want to add an item slicer to the "name" field.
Also, assuming that pivot table "pt" has a date field named "birthday",
and we want to add a Pivot Table Timeline Slicer.
You may have a question:
It is obvious that item slicer and timeline slicer can be added to a date field at the same time.
Can they work at the same time?
By default, no.
They all work through labelFilter. Setting textItems will cause the condition filter to be lost.
You can solve this problem with an option in PivotTable: allowMultipleFiltersPerField.
Try to Filter by clicking and dragging items in the Slicer.
With Item Slicer, you can also try pressing the shift and ctrl keys (for Windows) / command key (for Mac) when clicking or dragging.
Shape Base
Pivot Slicer is based on Shape, so you can use some Shape API to control Pivot Slicer
For example
Connect With PivotTable
Pivot Slicer supports connection management, including connecting or disconnecting the PivotTable.
If disconnecting from a PivotTable, the slicer filter action will not affect the PivotTable.
PivotTable filter actions will also not affect a Slicer.
For example, through this capability, you can use a slicer to manage multiple PivotTables from the same source.
Assuming that there are two PivotTables "pt1" and "pt2", both of them are created from a table called "table1", so they have same data source and fields.
Now you can use slicer_name to control the filters of two PivotTables.
import { Component, NgModule, enableProdMode } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { FormsModule } from '@angular/forms';
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { SpreadSheetsModule } from '@mescius/spread-sheets-angular';
import GC from '@mescius/spread-sheets';
import "@mescius/spread-sheets-shapes";
import "@mescius/spread-sheets-slicers";
import "@mescius/spread-sheets-pivot-addon";
import './styles.css';
@Component({
selector: 'app-component',
templateUrl: 'src/app.component.html'
})
export class AppComponent {
hostStyle = {
width: 'calc(100% - 330px)',
height: '100%',
overflow: 'hidden',
float: 'left'
};
name: string;
captionName: string;
x: number;
y: number;
width: number;
height: number;
connectPT1: boolean;
connectPT2: boolean;
activeSlicer: any;
sheet: GC.Spread.Sheets.Worksheet;
slicerCount = 0;
constructor() {
}
initSpread($event: any) {
let spread = $event.spread;
this.initSheets(spread);
let pivotLayoutSheet = spread.getSheet(0);
this.initPivotTable(pivotLayoutSheet);
this.initSlicer(pivotLayoutSheet);
this.bindEvents();
}
initSheets (spread: GC.Spread.Sheets.Workbook) {
spread.suspendPaint();
spread.setSheetCount(2);
let sheet = spread.getSheet(1);
sheet.name("DataSource");
sheet.setRowCount(650);
sheet.setColumnWidth(5, 120);
sheet.getCell(-1, 5).formatter("YYYY-mm-DD");
sheet.getRange(-1,4,0,1).formatter("$ #,##0");
sheet.setArray(0, 0, pivotSales);
let table = sheet.tables.add('tableSales', 0, 0, 637, 6);
table.style(GC.Spread.Sheets.Tables.TableThemes["none"]);
let sheet0 = spread.getSheet(0);
sheet0.name("PivotLayout");
sheet0.setValue(0, 0, "Pivot Table 1");
sheet0.setValue(0, 10, "Pivot Table 2");
spread.resumePaint();
this.sheet = sheet0;
}
initPivotTable(sheet: GC.Spread.Sheets.Worksheet) {
let groupInfo = { originFieldName: "date", dateGroups: [{ by: GC.Pivot.DateGroupType.quarters }, {by: GC.Pivot.DateGroupType.years}, {by: GC.Pivot.DateGroupType.months}] };
let pt1 = sheet.pivotTables.add("pt1", "tableSales", 1, 0, GC.Spread.Pivot.PivotTableLayoutType.outline, GC.Spread.Pivot.PivotTableThemes.light8);
pt1.suspendLayout();
pt1.options.showRowHeader = true;
pt1.options.showColumnHeader = true;
pt1.options.subtotalsPosition = GC.Spread.Pivot.SubtotalsPosition.top;
pt1.layoutType(GC.Spread.Pivot.PivotTableLayoutType.compact);
pt1.add("region", "region", GC.Spread.Pivot.PivotTableFieldType.rowField);
pt1.add("country", "country", GC.Spread.Pivot.PivotTableFieldType.rowField);
pt1.add("city", "city", GC.Spread.Pivot.PivotTableFieldType.rowField);
pt1.add("amount", "amounts", GC.Spread.Pivot.PivotTableFieldType.valueField, GC.Pivot.SubtotalType.sum);
pt1.resumeLayout();
pt1.autoFitColumn();
let pt2 = sheet.pivotTables.add("pt2", "tableSales", 1, 10, GC.Spread.Pivot.PivotTableLayoutType.outline, GC.Spread.Pivot.PivotTableThemes.medium23);
pt2.suspendLayout();
pt2.options.showRowHeader = true;
pt2.options.showColumnHeader = true;
pt2.options.subtotalsPosition = GC.Spread.Pivot.SubtotalsPosition.top;
pt2.layoutType(GC.Spread.Pivot.PivotTableLayoutType.compact);
pt2.group(groupInfo);
pt2.add("Years (date)", "Years (date)", GC.Spread.Pivot.PivotTableFieldType.rowField);
pt2.add("Quarters (date)", "Quarters (date)", GC.Spread.Pivot.PivotTableFieldType.rowField);
pt2.add("Months (date)", "Months (date)", GC.Spread.Pivot.PivotTableFieldType.rowField);
pt2.add("amount", "Amounts", GC.Spread.Pivot.PivotTableFieldType.valueField, GC.Pivot.SubtotalType.sum);
pt2.resumeLayout();
pt2.autoFitColumn();
}
initSlicer (sheet: GC.Spread.Sheets.Worksheet) {
sheet.suspendPaint();
let yearSlicer = sheet.slicers.add("Years", 'pt2', "date", GC.Spread.Sheets.Slicers.TimelineStyles.light5(), GC.Spread.Sheets.Slicers.SlicerType.pivotTimeline);
let monthSlicer = sheet.slicers.add("Months", 'pt2', "date", GC.Spread.Sheets.Slicers.TimelineStyles.light1(), GC.Spread.Sheets.Slicers.SlicerType.pivotTimeline);
this.setTimelineProp(yearSlicer, 967, 20, 310, 160, 1, "Years");
this.setTimelineProp(monthSlicer, 967, 160, 310, 160, 3, "Months");
let regionSlicer = sheet.slicers.add("region", 'pt1', "region", GC.Spread.Sheets.Slicers.SlicerStyles.dark1(), GC.Spread.Sheets.Slicers.SlicerType.pivotTable);
let countrySlicer = sheet.slicers.add("country", 'pt1', "country", GC.Spread.Sheets.Slicers.SlicerStyles.dark2(), GC.Spread.Sheets.Slicers.SlicerType.pivotTable);
let citySlicer = sheet.slicers.add("city", 'pt1', "city", GC.Spread.Sheets.Slicers.SlicerStyles.dark3(), GC.Spread.Sheets.Slicers.SlicerType.pivotTable);
this.setSlicerProp(regionSlicer, 285, 20, 140, 200, 1, true, true);
this.setSlicerProp(countrySlicer, 425, 20, 140, 200, 1, true, true);
this.setSlicerProp(citySlicer, 565, 20, 140, 200, 1, true, true);
sheet.resumePaint();
}
setSlicerProp(slicer: GC.Spread.Sheets.Slicers.ISlicer, x: number, y: number, width: number, height: number, columnCount: number, showHeader: boolean, showNoDataItemsInLast: boolean) {
slicer.position({x, y});
slicer.width(width);
slicer.height(height);
if (columnCount) {
slicer.columnCount(columnCount);
}
slicer.showHeader(!!showHeader);
slicer.showNoDataItemsInLast(!!showNoDataItemsInLast);
slicer.allowMove(false);
slicer.allowResize(false);
}
setTimelineProp (timeline, x, y, width, height, level, caption) {
timeline.position({x, y});
timeline.width(width);
timeline.height(height);
timeline.level(level);
timeline.captionName(caption);
timeline.allowMove(false);
timeline.allowResize(false);
}
bindEvents() {
let self = this;
let sheet = this.sheet as any;
sheet.bind(GC.Spread.Sheets.Events.SlicerChanged, function () {
let slicers = sheet.slicers.all();
for (let i = 0; i < slicers.length; i++) {
if (slicers[i].isSelected()) {
self.activeSlicer = slicers[i];
self.updateSlicerInfo();
break;
}
}
});
}
changeProperty(prop: string, v?: any) {
if (!this.activeSlicer) {
return;
}
v = v || this[prop];
if (v !== null && v !== undefined && v !== '') {
this.activeSlicer[prop](v);
}
}
updateSlicerInfo() {
if (!this.activeSlicer) {
return;
}
let slicer = this.activeSlicer;
this.name = slicer.name();
this.captionName = slicer.captionName();
this.x = slicer.x();
this.y = slicer.y();
this.width = slicer.width();
this.height = slicer.height();
this.connectPT1 = slicer.isConnectedPivotTable('pt1');
this.connectPT2 = slicer.isConnectedPivotTable('pt2');
}
changeConnection (id: number) {
let connect = id === 1 ? this.connectPT1 : this.connectPT2;
let ptName = id === 1 ? 'pt1' : 'pt2';
let slicer = this.activeSlicer;
if(slicer) {
if (connect) {
slicer.connectPivotTable(ptName);
} else {
slicer.disconnectPivotTable(ptName);
}
}
}
}
@NgModule({
imports: [BrowserModule, SpreadSheetsModule, FormsModule],
declarations: [AppComponent],
exports: [AppComponent],
bootstrap: [AppComponent]
})
export class AppModule {}
enableProdMode();
// Bootstrap application with hash style navigation and global services.
platformBrowserDynamic().bootstrapModule(AppModule);
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/angular/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/spread/source/data/pivotSales.js" type="text/javascript"></script>
<!-- Polyfills -->
<script src="$DEMOROOT$/en/angular/node_modules/zone.js/fesm2015/zone.min.js"></script>
<!-- SystemJS -->
<script src="$DEMOROOT$/en/angular/node_modules/systemjs/dist/system.js"></script>
<script src="systemjs.config.js"></script>
<script>
// workaround to load 'rxjs/operators' from the rxjs bundle
System.import('rxjs').then(function (m) {
System.import('@angular/compiler');
System.set(SystemJS.resolveSync('rxjs/operators'), System.newModule(m.operators));
System.import('$DEMOROOT$/en/lib/angular/license.ts');
System.import('./src/app.component');
});
</script>
</head>
<body>
<app-component></app-component>
</body>
</html>
<div class="sample-tutorial">
<gc-spread-sheets [hostStyle]="hostStyle" (workbookInitialized)="initSpread($event)">
</gc-spread-sheets>
<div class="options-container">
<div class="block slicer-infos">
<div>Current Selected Slicer Info:</div><br>
<div class="slicer-info">
<label class="info-label">Slicer Name:</label>
<input class="info-input" id="name" [(ngModel)]="name" (change)="changeProperty('name')"/>
</div>
<div class="slicer-info">
<label class="info-label">Caption Name:</label>
<input class="info-input" id="captionName" [(ngModel)]="captionName" (change)="changeProperty('captionName')"/>
</div>
<div class="slicer-info">
<label class="info-label">X:</label>
<input type="number" class="info-input" name="x" id="x" min="0" max="1000" step="1" [(ngModel)]="x" (change)="changeProperty('x')"/>
</div>
<div class="slicer-info">
<label class="info-label">Y:</label>
<input type="number" class="info-input" name="y" id="y" min="0" max="1000" step="1" [(ngModel)]="y" (change)="changeProperty('y')"/>
</div>
<div class="slicer-info">
<label class="info-label">Width:</label>
<input type="number" class="info-input" name="width" id="width" min="0" max="1000" step="1" [(ngModel)]="width" (change)="changeProperty('width')"/>
</div>
<div class="slicer-info">
<label class="info-label">Height:</label>
<input type="number" class="info-input" name="height" id="height" min="0" max="1000" step="1" [(ngModel)]="height" (change)="changeProperty('height')"/>
</div>
</div>
<div class="block">
<div>Slicer Connection</div><br/>
<div class="Connection">
<div class="slicer-info">
<input type="checkbox" id="pt1" [(ngModel)]="connectPT1" (change)="changeConnection(1)"/>
<label for="pt1">Connect Pivot Table 1</label>
</div>
<div class="slicer-info">
<input type="checkbox" id="pt2" [(ngModel)]="connectPT2" (change)="changeConnection(2)"/>
<label for="pt2">Connect Pivot Table 2</label>
</div>
</div>
</div>
</div>
</div>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 330px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 330px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
.slicer-info {
margin-top: 5px;
margin-bottom: 5px;
}
.block {
border: 1px solid gray;
padding-left: 5px;
padding-top: 10px;
padding-bottom: 10px;
margin-bottom: 1px;
}
.info-label {
width: 35%;
display: inline-block;
}
.info-input {
width: 58%;
display: inline-block;
}
(function (global) {
System.config({
transpiler: 'ts',
typescriptOptions: {
tsconfig: true
},
meta: {
'typescript': {
"exports": "ts"
},
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/',
'cdn:': 'https://cdn.mescius.io/demoapps/packages/spreadjs/19.1.2-master-2026-06-10-2131/'
},
// map tells the System loader where to look for things
map: {
'zone': 'npm:zone.js/fesm2015/zone.min.js',
'rxjs': 'npm:rxjs/dist/bundles/rxjs.umd.min.js',
'@angular/core': 'npm:@angular/core/fesm2022',
'@angular/common': 'npm:@angular/common/fesm2022/common.mjs',
'@angular/compiler': 'npm:@angular/compiler/fesm2022/compiler.mjs',
'@angular/platform-browser': 'npm:@angular/platform-browser/fesm2022/platform-browser.mjs',
'@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic/fesm2022/platform-browser-dynamic.mjs',
'@angular/common/http': 'npm:@angular/common/fesm2022/http.mjs',
'@angular/router': 'npm:@angular/router/fesm2022/router.mjs',
'@angular/forms': 'npm:@angular/forms/fesm2022/forms.mjs',
'jszip': 'npm:jszip/dist/jszip.min.js',
'typescript': 'npm:typescript/lib/typescript.js',
'ts': './plugin.js',
'tslib':'npm:tslib/tslib.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js',
'@mescius/spread-sheets': 'cdn:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-shapes': 'cdn:@mescius/spread-sheets-shapes/index.js',
'@mescius/spread-sheets-slicers': 'cdn:@mescius/spread-sheets-slicers/index.js',
'@mescius/spread-sheets-pivot-addon': 'cdn:@mescius/spread-sheets-pivot-addon/index.js',
'@mescius/spread-sheets-angular': 'cdn:@mescius/spread-sheets-angular/fesm2020/mescius-spread-sheets-angular.mjs',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'ts'
},
rxjs: {
defaultExtension: 'js'
},
"node_modules": {
defaultExtension: 'js'
},
"node_modules/@angular": {
defaultExtension: 'mjs'
},
"@mescius/spread-sheets-angular": {
defaultExtension: 'mjs'
},
'@angular/core': {
defaultExtension: 'mjs',
main: 'core.mjs'
}
}
});
})(this);

Introduction
SpreadJS PivotTable supports two types of slicers:
Item slicerTimeline slicer
Same with table slicer, pivot slicer is also managed through slicer collection.
SpreadJS defined SlicerType to distinguish which type of slicer will be added.
Pivot Slicers work with 3 plugins: shapes, slicers, pivot-addon.
Item Slicers can be added to any field (excluding the Calc field).
The changes made on an Item Slicer are equal to using the manual filter, which means "textItems" in the label filter.
Only Timeline Slicer can be added to the Date type field.
The changes made on Timeline Slicer are equal to using the label condition filter, which means "condition" in the label filter.
For example, if we want to add a Pivot Table Item Slicer.
Assuming that we have created a PivotTable named "pt".
If want to add an item slicer to the "name" field.
Also, assuming that pivot table "pt" has a date field named "birthday",
and we want to add a Pivot Table Timeline Slicer.
You may have a question:
It is obvious that item slicer and timeline slicer can be added to a date field at the same time.
Can they work at the same time?
By default, no.
They all work through labelFilter. Setting textItems will cause the condition filter to be lost.
You can solve this problem with an option in PivotTable: allowMultipleFiltersPerField.
Try to Filter by clicking and dragging items in the Slicer.
With Item Slicer, you can also try pressing the shift and ctrl keys (for Windows) / command key (for Mac) when clicking or dragging.
Shape Base
Pivot Slicer is based on Shape, so you can use some Shape API to control Pivot Slicer
For example
Connect With PivotTable
Pivot Slicer supports connection management, including connecting or disconnecting the PivotTable.
If disconnecting from a PivotTable, the slicer filter action will not affect the PivotTable.
PivotTable filter actions will also not affect a Slicer.
For example, through this capability, you can use a slicer to manage multiple PivotTables from the same source.
Assuming that there are two PivotTables "pt1" and "pt2", both of them are created from a table called "table1", so they have same data source and fields.
Now you can use slicer_name to control the filters of two PivotTables.
import * as React from 'react';
import { createRoot } from 'react-dom/client';
import './styles.css';
import { AppFunc } from './app-func';
import { App } from './app-class';
// 1. Functional Component sample
createRoot(document.getElementById('app')).render(<AppFunc />);
// 2. Class Component sample
// createRoot(document.getElementById('app')).render(<App />);
import * as React from 'react';
import GC from '@mescius/spread-sheets';
import "@mescius/spread-sheets-shapes";
import "@mescius/spread-sheets-slicers";
import "@mescius/spread-sheets-pivot-addon";
import { SpreadSheets } from '@mescius/spread-sheets-react';
import './styles.css';
const useEffect = React.useEffect;
export function AppFunc() {
const [spread, setSpread] = React.useState(null);
let initSpread = function (value) {
setSpread(value);
value.setSheetCount(2);
initSheets(value);
let pivotLayoutSheet = value.getSheet(0);
initPivotTable(pivotLayoutSheet);
}
let initSheets = function (spread) {
spread.suspendPaint();
spread.setSheetCount(2);
let sheet = spread.getSheet(1);
sheet.name("DataSource");
sheet.setRowCount(650);
sheet.setColumnWidth(5, 120);
sheet.getCell(-1, 5).formatter("YYYY-mm-DD");
sheet.getRange(-1, 4, 0, 1).formatter("$ #,##0");
sheet.setArray(0, 0, pivotSales);
let table = sheet.tables.add('tableSales', 0, 0, 637, 6);
table.style(GC.Spread.Sheets.Tables.TableThemes["none"]);
let sheet0 = spread.getSheet(0);
sheet0.name("PivotLayout");
sheet0.setValue(0, 0, "Pivot Table 1");
sheet0.setValue(0, 10, "Pivot Table 2");
spread.resumePaint();
}
let initPivotTable = function (sheet) {
var groupInfo = { originFieldName: "date", dateGroups: [{ by: GC.Pivot.DateGroupType.quarters }, { by: GC.Pivot.DateGroupType.years }, { by: GC.Pivot.DateGroupType.months }] };
var pt1 = sheet.pivotTables.add("pt1", "tableSales", 1, 0, GC.Spread.Pivot.PivotTableLayoutType.outline, GC.Spread.Pivot.PivotTableThemes.light8);
pt1.suspendLayout();
pt1.options.showRowHeader = true;
pt1.options.showColumnHeader = true;
pt1.options.subtotalsPosition = GC.Spread.Pivot.SubtotalsPosition.top;
pt1.layoutType(GC.Spread.Pivot.PivotTableLayoutType.compact);
pt1.add("region", "region", GC.Spread.Pivot.PivotTableFieldType.rowField);
pt1.add("country", "country", GC.Spread.Pivot.PivotTableFieldType.rowField);
pt1.add("city", "city", GC.Spread.Pivot.PivotTableFieldType.rowField);
pt1.add("amount", "amounts", GC.Spread.Pivot.PivotTableFieldType.valueField, GC.Pivot.SubtotalType.sum);
pt1.resumeLayout();
pt1.autoFitColumn();
var pt2 = sheet.pivotTables.add("pt2", "tableSales", 1, 10, GC.Spread.Pivot.PivotTableLayoutType.outline, GC.Spread.Pivot.PivotTableThemes.medium23);
pt2.suspendLayout();
pt2.options.showRowHeader = true;
pt2.options.showColumnHeader = true;
pt2.options.subtotalsPosition = GC.Spread.Pivot.SubtotalsPosition.top;
pt2.layoutType(GC.Spread.Pivot.PivotTableLayoutType.compact);
pt2.group(groupInfo);
pt2.add("Years (date)", "Years (date)", GC.Spread.Pivot.PivotTableFieldType.rowField);
pt2.add("Quarters (date)", "Quarters (date)", GC.Spread.Pivot.PivotTableFieldType.rowField);
pt2.add("Months (date)", "Months (date)", GC.Spread.Pivot.PivotTableFieldType.rowField);
pt2.add("amount", "Amounts", GC.Spread.Pivot.PivotTableFieldType.valueField, GC.Pivot.SubtotalType.sum);
pt2.resumeLayout();
pt2.autoFitColumn();
}
return (
<div class="sample-tutorial">
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={spread => initSpread(spread)}>
</SpreadSheets>
</div>
<div class="options-container">
<PivotSlicer spread={spread}></PivotSlicer>
</div>
</div>
);
}
let activeSlicer = null;
let sheet = null;
function PivotSlicer({ spread }) {
const [state, setState] = React.useState({
name: "",
captionName: "",
x: 0,
y: 0,
width: 0,
height: 0,
connectPT1: false,
connectPT2: false,
});
useEffect(() => {
if (spread) {
sheet = spread.getSheet(0);
initSlicers();
bindEvents();
}
}, [spread]);
const initSlicers = () => {
sheet.suspendPaint();
let yearSlicer = sheet.slicers.add("Years", 'pt2', "date", GC.Spread.Sheets.Slicers.TimelineStyles.light5(), GC.Spread.Sheets.Slicers.SlicerType.pivotTimeline);
let monthSlicer = sheet.slicers.add("Months", 'pt2', "date", GC.Spread.Sheets.Slicers.TimelineStyles.light1(), GC.Spread.Sheets.Slicers.SlicerType.pivotTimeline);
setTimelineProp(yearSlicer, 967, 20, 310, 160, 1, "Years");
setTimelineProp(monthSlicer, 967, 160, 310, 160, 3, "Months");
let regionSlicer = sheet.slicers.add("region", 'pt1', "region", GC.Spread.Sheets.Slicers.SlicerStyles.dark1(), GC.Spread.Sheets.Slicers.SlicerType.pivotTable);
let countrySlicer = sheet.slicers.add("country", 'pt1', "country", GC.Spread.Sheets.Slicers.SlicerStyles.dark2(), GC.Spread.Sheets.Slicers.SlicerType.pivotTable);
let citySlicer = sheet.slicers.add("city", 'pt1', "city", GC.Spread.Sheets.Slicers.SlicerStyles.dark3(), GC.Spread.Sheets.Slicers.SlicerType.pivotTable);
setSlicerProp(regionSlicer, 285, 20, 140, 200, 1, true, true);
setSlicerProp(countrySlicer, 425, 20, 140, 200, 1, true, true);
setSlicerProp(citySlicer, 565, 20, 140, 200, 1, true, true);
sheet.resumePaint();
}
const bindEvents = () => {
sheet.bind(GC.Spread.Sheets.Events.SlicerChanged, function () {
let slicers = sheet.slicers.all();
for (let i = 0; i < slicers.length; i++) {
if (slicers[i].isSelected()) {
activeSlicer = slicers[i];
updateSlicerInfo();
break;
}
}
});
}
const setSlicerProp = (slicer, x, y, width, height, columnCount, showHeader, showNoDataItemsInLast) => {
slicer.position({ x, y });
slicer.width(width);
slicer.height(height);
if (columnCount) {
slicer.columnCount(columnCount);
}
slicer.showHeader(!!showHeader);
slicer.showNoDataItemsInLast(!!showNoDataItemsInLast);
slicer.allowMove(false);
slicer.allowResize(false);
}
const setTimelineProp = (timeline, x, y, width, height, level, caption) => {
timeline.position({ x, y });
timeline.width(width);
timeline.height(height);
timeline.level(level);
timeline.captionName(caption);
timeline.allowMove(false);
timeline.allowResize(false);
}
const updateSlicerInfo = () => {
if (!activeSlicer) {
return;
}
let slicer = activeSlicer;
setState({
...state,
name: slicer.name(),
captionName: slicer.captionName(),
x: slicer.x(),
y: slicer.y(),
width: slicer.width(),
height: slicer.height(),
connectPT1: slicer.isConnectedPivotTable('pt1'),
connectPT2: slicer.isConnectedPivotTable('pt2')
});
}
const changeConnection = (id) => {
let connect = id === 1 ? state.connectPT1 : state.connectPT2;
let ptName = id === 1 ? 'pt1' : 'pt2';
let slicer = activeSlicer;
if (slicer) {
if (connect) {
slicer.connectPivotTable(ptName);
} else {
slicer.disconnectPivotTable(ptName);
}
}
}
const changeProperty = (prop, v) => {
if (!activeSlicer) {
return;
}
if (v !== null && v !== undefined && v !== '') {
activeSlicer[prop](v);
}
}
return (
<div class="options-container">
<div class="block slicer-infos">
<div>Current Selected Slicer Info:</div><br />
<div class="slicer-info">
<label class="info-label">Slicer Name:</label>
<input class="info-input" id="name" value={state.name} onChange={e => { setState({ ...state, name: e.target.value }); changeProperty("name", e.target.value) }} />
</div>
<div class="slicer-info">
<label class="info-label">Caption Name:</label>
<input class="info-input" id="captionName" value={state.captionName} onChange={e => { setState({ ...state, captionName: e.target.value }); changeProperty("captionName", e.target.value) }} />
</div>
<div class="slicer-info">
<label class="info-label">X:</label>
<input class="info-input" type='number' id="x" value={state.x} onChange={e => { setState({ ...state, x: e.target.value }); changeProperty("x", e.target.value) }} />
</div>
<div class="slicer-info">
<label class="info-label">Y:</label>
<input class="info-input" type='number' id="y" value={state.y} onChange={e => { setState({ ...state, y: e.target.value }); changeProperty("y", e.target.value) }} />
</div>
<div class="slicer-info">
<label class="info-label">Width:</label>
<input class="info-input" type='number' id="width" value={state.width} onChange={e => { setState({ ...state, width: e.target.value }); changeProperty("width", e.target.value) }} />
</div>
<div class="slicer-info">
<label class="info-label">Height:</label>
<input class="info-input" type='number' id="height" value={state.height} onChange={e => { setState({ ...state, height: e.target.value }); changeProperty("height", e.target.value) }} />
</div>
</div>
<div class="block">
<div>Slicer Connection</div><br />
<div class="Connection">
<div class="slicer-info">
<input type="checkbox" id="pt1" checked={state.connectPT1} onChange={e => { setState({ ...state, connectPT1: e.target.checked }, () => { changeConnection(1); }) }} />
<label for="pt1">Connect Pivot Table 1</label>
</div>
<div class="slicer-info">
<input type="checkbox" id="pt2" checked={state.connectPT2} onChange={e => { setState({ ...state, connectPT2: e.target.checked }, () => { changeConnection(2); }) }} />
<label for="pt2">Connect Pivot Table 2</label>
</div>
</div>
</div>
</div>
);
}
import * as React from 'react';
import GC from '@mescius/spread-sheets';
import "@mescius/spread-sheets-shapes";
import "@mescius/spread-sheets-slicers";
import "@mescius/spread-sheets-pivot-addon";
import { SpreadSheets } from '@mescius/spread-sheets-react';
import './styles.css';
const Component = React.Component;
export class App extends Component {
constructor(props) {
super(props);
this.state = {
renderChild: false
}
}
render() {
return (
<div class="sample-tutorial">
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={spread => this.initSpread(spread)}>
</SpreadSheets>
</div>
{this.state.renderChild ?
(<div class="options-container">
<PivotSlicer spread={this.spread}></PivotSlicer>
</div>) : ""}
</div>
);
}
componentDidMount() {
this.setState(() => ({
renderChild: true
}))
}
initSpread(spread) {
this.spread = spread;
spread.setSheetCount(2);
this.initSheets(spread);
let pivotLayoutSheet = spread.getSheet(0);
this.initPivotTable(pivotLayoutSheet);
}
initSheets (spread) {
spread.suspendPaint();
spread.setSheetCount(2);
let sheet = spread.getSheet(1);
sheet.name("DataSource");
sheet.setRowCount(650);
sheet.setColumnWidth(5, 120);
sheet.getCell(-1, 5).formatter("YYYY-mm-DD");
sheet.getRange(-1,4,0,1).formatter("$ #,##0");
sheet.setArray(0, 0, pivotSales);
let table = sheet.tables.add('tableSales', 0, 0, 637, 6);
table.style(GC.Spread.Sheets.Tables.TableThemes["none"]);
let sheet0 = spread.getSheet(0);
sheet0.name("PivotLayout");
sheet0.setValue(0, 0, "Pivot Table 1");
sheet0.setValue(0, 10, "Pivot Table 2");
spread.resumePaint();
}
initPivotTable(sheet) {
var groupInfo = { originFieldName: "date", dateGroups: [{ by: GC.Pivot.DateGroupType.quarters }, {by: GC.Pivot.DateGroupType.years}, {by: GC.Pivot.DateGroupType.months}] };
var pt1 = sheet.pivotTables.add("pt1", "tableSales", 1, 0, GC.Spread.Pivot.PivotTableLayoutType.outline, GC.Spread.Pivot.PivotTableThemes.light8);
pt1.suspendLayout();
pt1.options.showRowHeader = true;
pt1.options.showColumnHeader = true;
pt1.options.subtotalsPosition = GC.Spread.Pivot.SubtotalsPosition.top;
pt1.layoutType(GC.Spread.Pivot.PivotTableLayoutType.compact);
pt1.add("region", "region", GC.Spread.Pivot.PivotTableFieldType.rowField);
pt1.add("country", "country", GC.Spread.Pivot.PivotTableFieldType.rowField);
pt1.add("city", "city", GC.Spread.Pivot.PivotTableFieldType.rowField);
pt1.add("amount", "amounts", GC.Spread.Pivot.PivotTableFieldType.valueField, GC.Pivot.SubtotalType.sum);
pt1.resumeLayout();
pt1.autoFitColumn();
var pt2 = sheet.pivotTables.add("pt2", "tableSales", 1, 10, GC.Spread.Pivot.PivotTableLayoutType.outline, GC.Spread.Pivot.PivotTableThemes.medium23);
pt2.suspendLayout();
pt2.options.showRowHeader = true;
pt2.options.showColumnHeader = true;
pt2.options.subtotalsPosition = GC.Spread.Pivot.SubtotalsPosition.top;
pt2.layoutType(GC.Spread.Pivot.PivotTableLayoutType.compact);
pt2.group(groupInfo);
pt2.add("Years (date)", "Years (date)", GC.Spread.Pivot.PivotTableFieldType.rowField);
pt2.add("Quarters (date)", "Quarters (date)", GC.Spread.Pivot.PivotTableFieldType.rowField);
pt2.add("Months (date)", "Months (date)", GC.Spread.Pivot.PivotTableFieldType.rowField);
pt2.add("amount", "Amounts", GC.Spread.Pivot.PivotTableFieldType.valueField, GC.Pivot.SubtotalType.sum);
pt2.resumeLayout();
pt2.autoFitColumn();
}
}
class PivotSlicer extends Component {
constructor(props) {
super(props);
this.state = {
name: "",
captionName: "",
x: 0,
y: 0,
width: 0,
height: 0,
connectPT1: false,
connectPT2: false,
}
this.activeSlicer = null;
this.sheet = this.props.spread.getSheet(0);
this.initSlicers();
this.bindEvents();
}
initSlicers () {
let sheet = this.sheet;
sheet.suspendPaint();
let yearSlicer = sheet.slicers.add("Years", 'pt2', "date", GC.Spread.Sheets.Slicers.TimelineStyles.light5(), GC.Spread.Sheets.Slicers.SlicerType.pivotTimeline);
let monthSlicer = sheet.slicers.add("Months", 'pt2', "date", GC.Spread.Sheets.Slicers.TimelineStyles.light1(), GC.Spread.Sheets.Slicers.SlicerType.pivotTimeline);
this.setTimelineProp(yearSlicer, 967, 20, 310, 160, 1, "Years");
this.setTimelineProp(monthSlicer, 967, 160, 310, 160, 3, "Months");
let regionSlicer = sheet.slicers.add("region", 'pt1', "region", GC.Spread.Sheets.Slicers.SlicerStyles.dark1(), GC.Spread.Sheets.Slicers.SlicerType.pivotTable);
let countrySlicer = sheet.slicers.add("country", 'pt1', "country", GC.Spread.Sheets.Slicers.SlicerStyles.dark2(), GC.Spread.Sheets.Slicers.SlicerType.pivotTable);
let citySlicer = sheet.slicers.add("city", 'pt1', "city", GC.Spread.Sheets.Slicers.SlicerStyles.dark3(), GC.Spread.Sheets.Slicers.SlicerType.pivotTable);
this.setSlicerProp(regionSlicer, 285, 20, 140, 200, 1, true, true);
this.setSlicerProp(countrySlicer, 425, 20, 140, 200, 1, true, true);
this.setSlicerProp(citySlicer, 565, 20, 140, 200, 1, true, true);
sheet.resumePaint();
}
bindEvents () {
let self = this;
let sheet = this.sheet;
sheet.bind(GC.Spread.Sheets.Events.SlicerChanged, function () {
let slicers = sheet.slicers.all();
for (let i = 0; i < slicers.length; i++) {
if (slicers[i].isSelected()) {
self.activeSlicer = slicers[i];
self.updateSlicerInfo();
break;
}
}
});
}
setSlicerProp(slicer, x, y, width, height, columnCount, showHeader, showNoDataItemsInLast) {
slicer.position({x, y});
slicer.width(width);
slicer.height(height);
if (columnCount) {
slicer.columnCount(columnCount);
}
slicer.showHeader(!!showHeader);
slicer.showNoDataItemsInLast(!!showNoDataItemsInLast);
slicer.allowMove(false);
slicer.allowResize(false);
}
setTimelineProp (timeline, x, y, width, height, level, caption) {
timeline.position({x, y});
timeline.width(width);
timeline.height(height);
timeline.level(level);
timeline.captionName(caption);
timeline.allowMove(false);
timeline.allowResize(false);
}
updateSlicerInfo () {
if (!this.activeSlicer) {
return;
}
let slicer = this.activeSlicer;
this.setState({
name: slicer.name(),
captionName: slicer.captionName(),
x: slicer.x(),
y: slicer.y(),
width: slicer.width(),
height: slicer.height(),
connectPT1: slicer.isConnectedPivotTable('pt1'),
connectPT2: slicer.isConnectedPivotTable('pt2')
});
}
changeConnection (id) {
let connect = id === 1 ? this.state.connectPT1 : this.state.connectPT2;
let ptName = id === 1 ? 'pt1' : 'pt2';
let slicer = this.activeSlicer;
if(slicer) {
if (connect) {
slicer.connectPivotTable(ptName);
} else {
slicer.disconnectPivotTable(ptName);
}
}
}
changeProperty(prop, v) {
if (!this.activeSlicer) {
return;
}
if (v !== null && v !== undefined && v !== '') {
this.activeSlicer[prop](v);
}
}
render() {
return (
<div class="options-container">
<div class="block slicer-infos">
<div>Current Selected Slicer Info:</div><br/>
<div class="slicer-info">
<label class="info-label">Slicer Name:</label>
<input class="info-input" id="name" value={this.state.name} onChange={e => {this.setState({name: e.target.value}); this.changeProperty("name", e.target.value)}}/>
</div>
<div class="slicer-info">
<label class="info-label">Caption Name:</label>
<input class="info-input" id="captionName" value={this.state.captionName} onChange={e => {this.setState({captionName: e.target.value}); this.changeProperty("captionName", e.target.value)}}/>
</div>
<div class="slicer-info">
<label class="info-label">X:</label>
<input class="info-input" type='number' id="x" value={this.state.x} onChange={e => {this.setState({x: e.target.value}); this.changeProperty("x", e.target.value)}}/>
</div>
<div class="slicer-info">
<label class="info-label">Y:</label>
<input class="info-input" type='number' id="y" value={this.state.y} onChange={e => {this.setState({y: e.target.value}); this.changeProperty("y", e.target.value)}}/>
</div>
<div class="slicer-info">
<label class="info-label">Width:</label>
<input class="info-input" type='number' id="width" value={this.state.width} onChange={e => {this.setState({width: e.target.value}); this.changeProperty("width", e.target.value)}}/>
</div>
<div class="slicer-info">
<label class="info-label">Height:</label>
<input class="info-input" type='number' id="height" value={this.state.height} onChange={e => {this.setState({height: e.target.value}); this.changeProperty("height", e.target.value)}}/>
</div>
</div>
<div class="block">
<div>Slicer Connection</div><br/>
<div class="Connection">
<div class="slicer-info">
<input type="checkbox" id="pt1" checked={this.state.connectPT1} onChange={e => {this.setState({connectPT1: e.target.checked}, () => {this.changeConnection(1);})}}/>
<label for="pt1">Connect Pivot Table 1</label>
</div>
<div class="slicer-info">
<input type="checkbox" id="pt2" checked={this.state.connectPT2} onChange={e => {this.setState({connectPT2: e.target.checked}, () => {this.changeConnection(2);})}}/>
<label for="pt2">Connect Pivot Table 2</label>
</div>
</div>
</div>
</div>
);
}
}
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/react/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/spread/source/data/pivotSales.js" type="text/javascript"></script>
<!-- SystemJS -->
<script src="$DEMOROOT$/en/react/node_modules/systemjs/dist/system.src.js"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('$DEMOROOT$/en/lib/react/license.js').then(function () {
System.import('./src/app');
});
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
.sample-tutorial {
position: relative;
height: 98vh;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 330px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 330px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
.slicer-info {
margin-top: 5px;
margin-bottom: 5px;
}
.block {
border: 1px solid gray;
padding-left: 5px;
padding-top: 10px;
padding-bottom: 10px;
margin-bottom: 1px;
}
.info-label {
width: 35%;
display: inline-block;
}
.info-input {
width: 58%;
display: inline-block;
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
react: true
},
meta: {
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/',
'cdn:': 'https://cdn.mescius.io/demoapps/packages/spreadjs/19.1.2-master-2026-06-10-2131/'
},
// map tells the System loader where to look for things
map: {
'@mescius/spread-sheets': 'cdn:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-shapes': 'cdn:@mescius/spread-sheets-shapes/index.js',
'@mescius/spread-sheets-slicers': 'cdn:@mescius/spread-sheets-slicers/index.js',
'@mescius/spread-sheets-pivot-addon': 'cdn:@mescius/spread-sheets-pivot-addon/index.js',
'@mescius/spread-sheets-react': 'cdn:@mescius/spread-sheets-react/index.js',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js',
'react': 'npm:react/cjs/react.production.js',
'react-dom': 'npm:react-dom/cjs/react-dom.production.js',
'react-dom/client': 'npm:react-dom/cjs/react-dom-client.production.js',
'scheduler': 'npm:scheduler/cjs/scheduler.production.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'jsx'
},
"node_modules": {
defaultExtension: 'js'
},
}
});
})(this);

Introduction
SpreadJS PivotTable supports two types of slicers:
Item slicerTimeline slicer
Same with table slicer, pivot slicer is also managed through slicer collection.
SpreadJS defined SlicerType to distinguish which type of slicer will be added.
Pivot Slicers work with 3 plugins: shapes, slicers, pivot-addon.
Item Slicers can be added to any field (excluding the Calc field).
The changes made on an Item Slicer are equal to using the manual filter, which means "textItems" in the label filter.
Only Timeline Slicer can be added to the Date type field.
The changes made on Timeline Slicer are equal to using the label condition filter, which means "condition" in the label filter.
For example, if we want to add a Pivot Table Item Slicer.
Assuming that we have created a PivotTable named "pt".
If want to add an item slicer to the "name" field.
Also, assuming that pivot table "pt" has a date field named "birthday",
and we want to add a Pivot Table Timeline Slicer.
You may have a question:
It is obvious that item slicer and timeline slicer can be added to a date field at the same time.
Can they work at the same time?
By default, no.
They all work through labelFilter. Setting textItems will cause the condition filter to be lost.
You can solve this problem with an option in PivotTable: allowMultipleFiltersPerField.
Try to Filter by clicking and dragging items in the Slicer.
With Item Slicer, you can also try pressing the shift and ctrl keys (for Windows) / command key (for Mac) when clicking or dragging.
Shape Base
Pivot Slicer is based on Shape, so you can use some Shape API to control Pivot Slicer
For example
Connect With PivotTable
Pivot Slicer supports connection management, including connecting or disconnecting the PivotTable.
If disconnecting from a PivotTable, the slicer filter action will not affect the PivotTable.
PivotTable filter actions will also not affect a Slicer.
For example, through this capability, you can use a slicer to manage multiple PivotTables from the same source.
Assuming that there are two PivotTables "pt1" and "pt2", both of them are created from a table called "table1", so they have same data source and fields.
Now you can use slicer_name to control the filters of two PivotTables.
<template>
<div class="sample-tutorial">
<gc-spread-sheets
class="sample-spreadsheets"
@workbookInitialized="initSpread"
>
<gc-worksheet> </gc-worksheet>
<gc-worksheet> </gc-worksheet>
</gc-spread-sheets>
<div class="options-container">
<div class="block slicer-infos">
<div>Current Selected Slicer Info:</div><br>
<div class="slicer-info">
<label class="info-label">Slicer Name:</label>
<input class="info-input" id="name" v-model="nameRef" @change="changeProperty('name')"/>
</div>
<div class="slicer-info">
<label class="info-label">Caption Name:</label>
<input class="info-input" id="captionName" v-model="captionNameRef" @change="changeProperty('captionName')"/>
</div>
<div class="slicer-info">
<label class="info-label">X:</label>
<input type="number" class="info-input" name="x" id="x" min="0" max="1000" step="1" v-model="xRef" @change="changeProperty('x')"/>
</div>
<div class="slicer-info">
<label class="info-label">Y:</label>
<input type="number" class="info-input" name="y" id="y" min="0" max="1000" step="1" v-model="yRef" @change="changeProperty('y')"/>
</div>
<div class="slicer-info">
<label class="info-label">Width:</label>
<input type="number" class="info-input" name="width" id="width" min="0" max="1000" step="1" v-model="widthRef" @change="changeProperty('width')"/>
</div>
<div class="slicer-info">
<label class="info-label">Height:</label>
<input type="number" class="info-input" name="height" id="height" min="0" max="1000" step="1" v-model="heightRef" @change="changeProperty('height')"/>
</div>
</div>
<div class="block">
<div>Slicer Connection</div><br/>
<div class="Connection">
<div class="slicer-info">
<input type="checkbox" id="pt1" v-model="connectPT1Ref" @change="changeConnection(1)"/>
<label for="pt1">Connect Pivot Table 1</label>
</div>
<div class="slicer-info">
<input type="checkbox" id="pt2" v-model="connectPT2Ref" @change="changeConnection(2)"/>
<label for="pt2">Connect Pivot Table 2</label>
</div>
</div>
</div>
</div>
</div>
</template>
<script setup>
import GC from "@mescius/spread-sheets";
import "@mescius/spread-sheets-shapes";
import "@mescius/spread-sheets-slicers";
import "@mescius/spread-sheets-vue";
import { shallowRef } from "vue";
import "@mescius/spread-sheets-pivot-addon";
let slicerProp = {};
let nameRef = shallowRef("");
let captionNameRef = shallowRef("");
let xRef = shallowRef(0);
let yRef = shallowRef(0);
let widthRef = shallowRef(0);
let heightRef = shallowRef(0);
let connectPT1Ref = shallowRef(false);
let connectPT2Ref = shallowRef(false);
let activeSlicerRef = shallowRef(null);
function initSpread (spread) {
initSheets(spread);
let pivotLayoutSheet = spread.getSheet(0);
initPivotTable(pivotLayoutSheet);
initSlicer(pivotLayoutSheet);
bindEvents(pivotLayoutSheet);
slicerProp["name"] = nameRef;
slicerProp["captionName"] = captionNameRef;
slicerProp["x"] = xRef;
slicerProp["y"] = yRef;
slicerProp["width"] = widthRef;
slicerProp["height"] = heightRef;
}
function initSheets (spread) {
spread.suspendPaint();
let sheet = spread.getSheet(1);
sheet.name("DataSource");
sheet.setRowCount(650);
sheet.setColumnWidth(5, 120);
sheet.getCell(-1, 5).formatter("YYYY-mm-DD");
sheet.getRange(-1, 4, 0, 1).formatter("$ #,##0");
sheet.setArray(0, 0, pivotSales);
let table = sheet.tables.add("tableSales", 0, 0, 637, 6);
table.style(GC.Spread.Sheets.Tables.TableThemes["none"]);
let sheet0 = spread.getSheet(0);
sheet0.setValue(0, 0, "Pivot Table 1");
sheet0.setValue(0, 10, "Pivot Table 2");
sheet0.name("PivotLayout");
spread.resumePaint();
}
function initPivotTable (sheet) {
let groupInfo = { originFieldName: "date", dateGroups: [{ by: GC.Pivot.DateGroupType.quarters }, {by: GC.Pivot.DateGroupType.years}, {by: GC.Pivot.DateGroupType.months}] };
let pt1 = sheet.pivotTables.add("pt1", "tableSales", 1, 0, GC.Spread.Pivot.PivotTableLayoutType.outline, GC.Spread.Pivot.PivotTableThemes.light8);
pt1.suspendLayout();
pt1.options.showRowHeader = true;
pt1.options.showColumnHeader = true;
pt1.options.subtotalsPosition = GC.Spread.Pivot.SubtotalsPosition.top;
pt1.layoutType(GC.Spread.Pivot.PivotTableLayoutType.compact);
pt1.add("region", "region", GC.Spread.Pivot.PivotTableFieldType.rowField);
pt1.add("country", "country", GC.Spread.Pivot.PivotTableFieldType.rowField);
pt1.add("city", "city", GC.Spread.Pivot.PivotTableFieldType.rowField);
pt1.add("amount", "amounts", GC.Spread.Pivot.PivotTableFieldType.valueField, GC.Pivot.SubtotalType.sum);
pt1.resumeLayout();
pt1.autoFitColumn();
let pt2 = sheet.pivotTables.add("pt2", "tableSales", 1, 10, GC.Spread.Pivot.PivotTableLayoutType.outline, GC.Spread.Pivot.PivotTableThemes.medium23);
pt2.suspendLayout();
pt2.options.showRowHeader = true;
pt2.options.showColumnHeader = true;
pt2.options.subtotalsPosition = GC.Spread.Pivot.SubtotalsPosition.top;
pt2.layoutType(GC.Spread.Pivot.PivotTableLayoutType.compact);
pt2.group(groupInfo);
pt2.add("Years (date)", "Years (date)", GC.Spread.Pivot.PivotTableFieldType.rowField);
pt2.add("Quarters (date)", "Quarters (date)", GC.Spread.Pivot.PivotTableFieldType.rowField);
pt2.add("Months (date)", "Months (date)", GC.Spread.Pivot.PivotTableFieldType.rowField);
pt2.add("amount", "Amounts", GC.Spread.Pivot.PivotTableFieldType.valueField, GC.Pivot.SubtotalType.sum);
pt2.resumeLayout();
pt2.autoFitColumn();
}
function initSlicer(sheet) {
sheet.suspendPaint();
let yearSlicer = sheet.slicers.add("Years", 'pt2', "date", GC.Spread.Sheets.Slicers.TimelineStyles.light5(), GC.Spread.Sheets.Slicers.SlicerType.pivotTimeline);
let monthSlicer = sheet.slicers.add("Months", 'pt2', "date", GC.Spread.Sheets.Slicers.TimelineStyles.light1(), GC.Spread.Sheets.Slicers.SlicerType.pivotTimeline);
setTimelineProp(yearSlicer, 967, 20, 310, 160, 1, "Years");
setTimelineProp(monthSlicer, 967, 160, 310, 160, 3, "Months");
let regionSlicer = sheet.slicers.add("region", 'pt1', "region", GC.Spread.Sheets.Slicers.SlicerStyles.dark1(), GC.Spread.Sheets.Slicers.SlicerType.pivotTable);
let countrySlicer = sheet.slicers.add("country", 'pt1', "country", GC.Spread.Sheets.Slicers.SlicerStyles.dark2(), GC.Spread.Sheets.Slicers.SlicerType.pivotTable);
let citySlicer = sheet.slicers.add("city", 'pt1', "city", GC.Spread.Sheets.Slicers.SlicerStyles.dark3(), GC.Spread.Sheets.Slicers.SlicerType.pivotTable);
setSlicerProp(regionSlicer, 285, 20, 140, 200, 1, true, true);
setSlicerProp(countrySlicer, 425, 20, 140, 200, 1, true, true);
setSlicerProp(citySlicer, 565, 20, 140, 200, 1, true, true);
sheet.resumePaint();
}
function setSlicerProp(slicer, x, y, width, height, columnCount, showHeader, showNoDataItemsInLast) {
slicer.position({x, y});
slicer.width(width);
slicer.height(height);
if (columnCount) {
slicer.columnCount(columnCount);
}
slicer.showHeader(!!showHeader);
slicer.showNoDataItemsInLast(!!showNoDataItemsInLast);
slicer.allowMove(false);
slicer.allowResize(false);
}
function setTimelineProp (timeline, x, y, width, height, level, caption) {
timeline.position({x, y});
timeline.width(width);
timeline.height(height);
timeline.level(level);
timeline.captionName(caption);
timeline.allowMove(false);
timeline.allowResize(false);
}
function bindEvents(sheet) {
sheet.bind(GC.Spread.Sheets.Events.SlicerChanged, function () {
let slicers = sheet.slicers.all();
for (let i = 0; i < slicers.length; i++) {
if (slicers[i].isSelected()) {
activeSlicerRef.value = slicers[i];
updateSlicerInfo();
break;
}
}
});
}
function changeProperty(prop, v) {
if (!activeSlicerRef.value) {
return;
}
v = v || slicerProp[prop].value;
if (v !== null && v !== undefined && v !== '') {
activeSlicerRef.value[prop](v);
}
}
function updateSlicerInfo() {
if (!activeSlicerRef.value) {
return;
}
let slicer = activeSlicerRef.value;
nameRef.value = slicer.name();
captionNameRef.value = slicer.captionName();
xRef.value = slicer.x();
yRef.value = slicer.y();
widthRef.value = slicer.width();
heightRef.value = slicer.height();
connectPT1Ref.value = slicer.isConnectedPivotTable('pt1');
connectPT2Ref.value = slicer.isConnectedPivotTable('pt2');
}
function changeConnection (id) {
let connect = id === 1 ? connectPT1Ref.value : connectPT2Ref.value;
let ptName = id === 1 ? 'pt1' : 'pt2';
let slicer = activeSlicerRef.value;
if(slicer) {
if (connect) {
slicer.connectPivotTable(ptName);
} else {
slicer.disconnectPivotTable(ptName);
}
}
}
</script>
<style scoped>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 330px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 330px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
font-size: 14px;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
.slicer-info {
margin-top: 5px;
margin-bottom: 5px;
}
.block {
border: 1px solid gray;
padding-left: 5px;
padding-top: 10px;
padding-bottom: 10px;
margin-bottom: 1px;
}
.info-label {
width: 35%;
display: inline-block;
}
.info-input {
width: 58%;
display: inline-block;
}
#app {
height: 100%;
}
</style>
<!DOCTYPE html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<title>SpreadJS VUE</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css"
href="$DEMOROOT$/en/vue3/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/spread/source/data/pivotSales.js" type="text/javascript"></script>
<script src="$DEMOROOT$/en/vue3/node_modules/systemjs/dist/system.src.js"></script>
<script src="./systemjs.config.js"></script>
<script src="./compiler.js" type="module"></script>
<script>
var System = SystemJS;
System.import("./src/app.js");
System.import('$DEMOROOT$/en/lib/vue3/license.js');
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
(function (global) {
SystemJS.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true
},
paths: {
// paths serve as alias
'npm:': 'node_modules/',
'cdn:': 'https://cdn.mescius.io/demoapps/packages/spreadjs/19.1.0-master-2026-05-10-2130/'
},
packageConfigPaths: [
'../node_modules/*/package.json',
"../node_modules/@mescius/*/package.json",
"../node_modules/@babel/*/package.json",
"../node_modules/@vue/*/package.json"
],
map: {
'vue': "npm:vue/dist/vue.esm-browser.js",
'tiny-emitter': 'npm:tiny-emitter/index.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
"systemjs-babel-build": "npm:systemjs-plugin-babel/systemjs-babel-browser.js",
'@mescius/spread-sheets': 'cdn:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-resources-en': 'cdn:@mescius/spread-sheets-resources-en/index.js',
'@mescius/spread-sheets-vue': 'cdn:@mescius/spread-sheets-vue/index.js',
'@mescius/spread-sheets-shapes': 'cdn:@mescius/spread-sheets-shapes/index.js',
'@mescius/spread-sheets-slicers': 'cdn:@mescius/spread-sheets-slicers/index.js',
'@mescius/spread-sheets-pivot-addon': 'cdn:@mescius/spread-sheets-pivot-addon/index.js',
},
meta: {
'*.css': { loader: 'systemjs-plugin-css' },
'*.vue': { loader: "../plugin-vue/index.js" }
}
});
})(this);